/* eslint-disable no-undef */
const Vomnibar = {
  vomnibarUI: null,
  
  // Extract any additional options from the command's registry entry.
  extractOptionsFromRegistryEntry (registryEntry, callback) {
    return callback ? callback(Object.assign({}, registryEntry.options)) : null;
  },
  
  // sourceFrameId here (and below) is the ID of the frame from which this request originates, which may be
  // different from the current frame. 
  activate (sourceFrameId, registryEntry) {
    return this.extractOptionsFromRegistryEntry(registryEntry, options => {
      return this.open(sourceFrameId, Object.assign(options, {completer: "omni"}));
    });
  },
  
  activateInNewTab (sourceFrameId, registryEntry) {
    return this.extractOptionsFromRegistryEntry(registryEntry, options => {
      return this.open(sourceFrameId, Object.assign(options, {completer: "omni", newTab: true}));
    });
  },
  
  activateTabSelection (sourceFrameId) {
    return this.open(sourceFrameId, {
      completer: "tabs",
      selectFirst: true
    });
  },
  
  // 搜书签(当前页)
  activateBookmarks (sourceFrameId) {
    return this.open(sourceFrameId, {
      completer: "bookmarks",
      selectFirst: true
    });
  },
  
  // 搜书签(新窗口)
  activateBookmarksInNewTab (sourceFrameId) {
    return this.open(sourceFrameId, {
      completer: "bookmarks",
      selectFirst: true,
      newTab: true
    });
  },
  
  // 编辑URL
  activateEditUrl (sourceFrameId) {
    return this.open(sourceFrameId, {
      completer: "omni",
      selectFirst: false,
      query: window.location.href
    });
  },
  
  //   编辑URL并在新窗口打开
  activateEditUrlInNewTab (sourceFrameId) {
    return this.open(sourceFrameId, {
      completer: "omni",
      selectFirst: false,
      query: window.location.href,
      newTab: true
    });
  },
  
  // 初始化 创建shadow
  init () {
    if (!this.vomnibarUI) { this.vomnibarUI = new UIComponent("packages/search-box/index.html", "vomnibarFrame", function () {}) }
  },
  
  // This function opens the vomnibar. It accepts options, a map with the values:
  //   completer   - The completer to fetch results from.
  //   query       - Optional. Text to prefill the Vomnibar with.
  //   selectFirst - Optional, boolean. Whether to select the first entry.
  //   newTab      - Optional, boolean. Whether to open the result in a new tab.
  open (sourceFrameId, options) {
    this.init();
    // The Vomnibar cannot coexist with the help dialog (it causes focus issues).
    // HelpDialog.abort();
    return this.vomnibarUI.activate(Object.assign(options, { name: "activate", sourceFrameId, focus: true }));
  }
};

global.Vomnibar = Vomnibar;
